/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals;

import java.util.GregorianCalendar;

/**
 *
 * @author Usuari
 */
public final class GammaBlanca extends Electrodomestic {

    private double mides[] = new double[3];     // Totes a zero
    // Contingut de les cel·les:
    // 0: altura
    // 1: amplada
    // 2: fondària

    public GammaBlanca(String nom, String marca, double preu, double[] mides) {
        super(nom, marca, preu);
        try {
            setMides(mides);
        } catch (RuntimeException ex) {
            qElectrodomesticsCreats--;
            throw ex;
        }
    }

    public GammaBlanca(String nom, String marca, double preu, Byte garantia,
            GregorianCalendar dataPatent, double altura, double amplada, double fondaria
    ) {
        super(nom, marca, preu, garantia, dataPatent);
        try {
            double mides[] = {altura, amplada, fondaria};
            setMides(mides);
        } catch (RuntimeException ex) {
            qElectrodomesticsCreats--;
            throw ex;
        }
    }

    public double[] getMides() {
        return mides;
    }

    public void setMides(double[] mides) {
        if (mides.length != 3) {
            throw new RuntimeException("Per assignar mides cal passar una taula de 3 cel·les");
        }
        if (mides[0] <= 0 || mides[1] <= 0 || mides[2] <= 0) {
            throw new RuntimeException("Les mides d'un electrodomèstic han de ser estrictament positives");
        }
        System.arraycopy(mides, 0, this.mides, 0, 3);
    }

    /* Per sentit comú, getter i setter per altura, amplada, fondaria */
    public void setAltura(double altura) {
        if (altura <= 0) {
            throw new RuntimeException("Altura ha de ser estrictament positiva");
        }
        mides[0] = altura;
    }

    public void setAmplada(double amplada) {
        if (amplada <= 0) {
            throw new RuntimeException("Ampladaha de ser estrictament positiva");
        }
        mides[1] = amplada;
    }

    public void setFondaria(double fondaria) {
        if (fondaria <= 0) {
            throw new RuntimeException("Fondària ha de ser estrictament positiva");
        }
        mides[2] = fondaria;
    }

    public double getAltura() {
        return mides[0];
    }

    public double getAmplada() {
        return mides[1];
    }

    public double getFondaria() {
        return mides[2];
    }

    @Override
    public String toString() {
        // Per accedir a camps privats de la classe base, cal usar els getter:
//        return "Electrodomestic Gamma Blanca {" + "nom=" + getNom() + ", altura=" + mides[0] + ", amplada=" + mides[1] + ", fondaria=" + mides[2] + '}';
        return "Gamma Blanca " + super.toString() + ", altura=" + mides[0] + ", amplada=" + mides[1] + ", fondaria=" + mides[2] + '}';
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        GammaBlanca gb = new GammaBlanca(this.getNom(), this.getMarca(), this.getPreu(), this.getGarantia(), this.getDataPatent(),
                this.mides[0], this.mides[1], this.mides[2]);
        return gb;
    }

}
