/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals;

import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormatSymbols;
import java.util.InputMismatchException;
import java.util.Scanner;

/**
 *
 * @author Usuari
 */
public class P1_GenerarFitxerTextViaFileWriter {

    static Scanner teclat = new Scanner(System.in);

    public static void main(String[] args) {
        final String nomFitxer = "fitxer.txt";
        FileWriter fw = null;
        try {
            fw = new FileWriter(nomFitxer);
        } catch (IOException ex) {
            System.out.println("No es pot obrir el fitxer " + nomFitxer);
            System.out.println("Info: " + ex.getMessage());
            return;
        }
        // Recuperar el caràcter que actua de separador decimal, per informar a l'usuari
        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
        char separador = dfs.getDecimalSeparator();

        try {
            char marca = llegirMarca();
            while (marca != '$') {
                fw.write(marca);
                boolean errorDadaUsuari = true;
                while (errorDadaUsuari) {
                    if (marca == 'F' || marca == 'D') {
                        System.out.println("Introdueixi valor de tipus " + marca + "(separador decimal:" + separador + ") :");
                    } else {
                        System.out.println("Introdueixi valor de tipus " + marca + ":");
                    }
                    errorDadaUsuari = false;
                    try {
                        switch (marca) {
                            case 'B':
                                Byte b = teclat.nextByte();
                                fw.write(b.toString() + " ");
                                break;
                            case 'S':
                                Short s = teclat.nextShort();
                                fw.write(s.toString() + " ");
                                break;
                            case 'I':
                                Integer i = teclat.nextInt();
                                fw.write(i.toString() + " ");
                                break;
                            case 'L':
                                Long l = teclat.nextLong();
                                fw.write(l.toString() + " ");
                                break;
                            case 'F':
                                Float f = teclat.nextFloat();
                                fw.write(f.toString() + " ");
                                break;
                            case 'D':
                                Double d = teclat.nextDouble();
                                fw.write(d.toString() + " ");
                                break;
                        }
                    } catch (InputMismatchException ex) {
                        System.out.println("El valor introduït no és adequat.");
                        if (ex.getMessage() != null) {
                            System.out.println("Més info: " + ex.getMessage());
                        }
                        errorDadaUsuari = true;
                        teclat.nextLine();  // Buidar teclat - Treure la dada errònia
                    }
                }
                teclat.nextLine();
                marca = llegirMarca();
            }
        } catch (IOException ioe) {
            System.out.println("Error en enregistrar");
            System.out.println("Més info: " + ioe.getMessage());
        } finally {
            try {
                fw.close();
            } catch (IOException ex) {
                System.out.println("Error en tancar el fitxer.");
                System.out.println("Més info: " + ex.getMessage());
            }
        }
    }

    public static char llegirMarca() {
        System.out.println("Introdueixi tipus dada (B/S/I/L/D/F) - $ per finalitzar:");
        String result = teclat.nextLine().toUpperCase();
        while (result.length() != 1 || !"BSILDF$".contains(result)) {
            System.out.println("Cal introduir obligatòriament un caràcter vàlid!");
            result = teclat.nextLine().toUpperCase();
        }
        return result.charAt(0);
    }
}
