/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals;

import java.io.DataInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 *
 * @author Usuari Programa que analitzi un fitxer textual de valors numèrics que
 * segueixen el format: <L><valor><espai><L><valor><espai><L><valor><espai>
 * on L : lletra identificadora del tipus de valor: B-byte | S-short | I-int | F
 * - float | L - long | D - double i informi del contingut del fitxer per la
 * consola
 */
public class P2_RecuperarFitxerTextViaFileReader {

    public static void main(String[] args) {
        List<Byte> lb = new ArrayList();
        List<Short> ls = new ArrayList();
        List<Integer> li = new ArrayList();
        List<Long> ll = new ArrayList();
        List<Float> lf = new ArrayList();
        List<Double> ld = new ArrayList();
        FileReader fr = null;
        String nomFitxer = "fitxer.txt";
        try {
            fr = new FileReader(nomFitxer);
            char c;
            int aux;
            while ((aux = fr.read()) != -1) {
                // aux conté la lletra llegida com a "int"
                // La passem a "char"
                c = (char) aux;
                c = Character.toUpperCase(c);   // Innecessari
                if (!"BSILFD".contains(Character.toString(c))) {
                    throw new IOException("Fitxer corrupte. S'ha detectat caràcter " + c + " no vàlid");
                }
                String cadenaLlegida = llegirFinsEspai(fr);
                try {
                    switch (c) {
                        case 'B':
                            lb.add(Byte.parseByte(cadenaLlegida));
                            break;
                        case 'S':
                            ls.add(Short.parseShort(cadenaLlegida));
                            break;
                        case 'I':
                            li.add(Integer.parseInt(cadenaLlegida));
                            break;
                        case 'L':
                            ll.add(Long.parseLong(cadenaLlegida));
                            break;
                        case 'F':
                            lf.add(Float.parseFloat(cadenaLlegida));
                            break;
                        case 'D':
                            ld.add(Double.parseDouble(cadenaLlegida));
                            break;
                    }
                } catch (NumberFormatException nfe) {
                    System.out.println("Valor no vàlid: " + c + cadenaLlegida);
                    System.out.println("No el considerem");
                }
            }
            // Ordenem les llistes i les visualitzem
            Collections.sort(lb); System.out.println("Valors Byte: " + lb);
            Collections.sort(ls); System.out.println("Valors Short: " + ls);
            Collections.sort(li); System.out.println("Valors Integer: " + li);
            Collections.sort(ll); System.out.println("Valors Long: " + ll);
            Collections.sort(lf); System.out.println("Valors Float: " + lf);
            Collections.sort(ld); System.out.println("Valors Double: " + ld);
        } catch (FileNotFoundException ex) {
            System.out.println("Error: " + ex.getMessage());
        } catch (IOException ex) {
            System.out.println("Error: " + ex.getMessage());
        } finally {
            if (fr != null) {
                try {
                    fr.close();
                } catch (IOException ex) {
                    System.out.println("Problemes en tancar el fitxer");
                    System.out.println("Info: " + ex.getMessage());
                }
            }
        }
    }

    private static String llegirFinsEspai(FileReader x) throws IOException {
        String r = "";
        int aux;
        while ((aux = x.read()) != -1) {
            // aux conté el valor int del caràcter llegit
            char c = (char) aux;
            if (c == ' ') {
                break;
            }
            r = r + c;
        }
        return r;
    }
}
