/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals;

import java.util.Arrays;
import java.util.GregorianCalendar;
import java.util.List;
import org.milaifontanals.persistence.ElectrodomesticFitxerBinariSerialitzat;
import org.milaifontanals.persistence.ElectrodomesticFitxerBinariSerialitzatException;

/**
 *
 * @author Usuari
 */
public class P01_GenerarFitxerBinari {

    public static void main(String[] args) {
        List<Electrodomestic> ll = crearLlista();
        Electrodomestic.setDteVigent(3.5F);

        System.out.println("Contingut d'objectes de la llista que enregistrem:");
        for (Electrodomestic el : ll) {
            System.out.println("\t" + el);
        }
        System.out.println("Valors de les dades estàtiques:");
        System.out.println("\tDte. Vigent: " + Electrodomestic.getDteVigent());
        System.out.println("\tElements creats: " + Electrodomestic.getqElectrodomesticsCreats());
        System.out.println("\tElements vius: " + Electrodomestic.getqElectrodomesticsVius());
        
        String nomFitxer = "LlistaElectrodomestic.bin";
        try {
            ElectrodomesticFitxerBinariSerialitzat.saveListElectrodomestic(ll, nomFitxer);
            System.out.println("Fitxer generat sense cap error");
        } catch (ElectrodomesticFitxerBinariSerialitzatException ex) {
            System.out.println("Error en generar arxiu " + nomFitxer);
            System.out.println("+ Info:" + ex.getMessage());
            Throwable aux = ex.getCause();
            while (aux != null) {
                if (aux.getMessage() != null) {
                    System.out.println("\t" + aux.getMessage());
                }
                aux = aux.getCause();
            }
        }
    }

    private static List<Electrodomestic> crearLlista() {
        // Aquest mètode crea una array d'electrodomèstics... aprofitat d'un altre
        // programa... Al final, es converteix en List amb utilitat Arrays.asList

        Electrodomestic[] array = new Electrodomestic[16];

        double[] mides = new double[3];
        mides[0] = 845;
        mides[1] = 598;
        mides[2] = 590;

        array[0] = new GammaBlanca("Rentadora", "Balay", 679.78, mides);
        array[1] = new GammaBlanca("Rentadora", "Miele",  749,null, null, 850, 596, 636);
        array[2] = new GammaGris("Portàtil", "HP", 499, "15S-fq2095ns");
        Byte g = 1;
        array[3] = new GammaGris("Portàtil", "Lenovo", 379, g, new GregorianCalendar(2020, 11, 29), "IdeaPad 3 15IGL05", "A", 16);
        mides[0] = 595;
        mides[1] = 595;
        mides[2] = 559;

        array[4] = new GammaBlanca("Forn", "Teka", 209.99, mides);
        array[5] = new GammaBlanca("Forn", "Balay", 199.99, (byte)2, new GregorianCalendar(), 595, 594, 595);
        array[6] = new GammaGris("Tablet", "Lenovo", 185, "Tab M10 FHD Plus");
        array[7] = new GammaGris("Tablet", "Huawei", 109, g, new GregorianCalendar(2021, 2, 15), "MatePadT 10", "B", 8);

        mides[0] = 203;
        mides[1] = 60;
        mides[2] = 65;

        array[8] = new GammaBlanca("Nevera", "Bosch", 579.99, mides);
        array[9] = new GammaBlanca("Nevera", "Fagor", 599, (byte)5, null, 186, 60, 65);
        array[10] = new GammaGris("Impressora", "Brother", 739, "HL-L9310CDW");
        array[11] = new GammaGris("Impressora", "Canon", 78.99, "PIXMA MG3650S");

        mides[0] = 85;
        mides[1] = 60;
        mides[2] = 60;

        array[12] = new GammaBlanca("Rentaplats", "Indesit", 374, mides);
        array[13] = new GammaBlanca("Rentaplats", "Electrolux", 429, null, null, 85, 60, 62.5);
        array[14] = new GammaGris("Impressora", "Epson", 184, "ECOTANK ET-2714");
        array[15] = new GammaGris("Impressora", "HP", 54.99, "DeskJet 2721e");

        List ll = Arrays.asList(array);
        return ll;
    }

}
