/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals.persistence;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.List;
import org.milaifontanals.Electrodomestic;

/**
 *
 * @author Usuari
 */
public class ElectrodomesticFitxerBinariSerialitzat {

    private ElectrodomesticFitxerBinariSerialitzat() {
    }

    /**
     * Crear un fitxer que contingui la llista d'electrodomèstics
     *
     * @param ll llista d'electrodomèstics a fer persistents
     * @param nomFitxer fitxer on enregistrar els electrodomèstics
     * (sobreescriure'l si existeix)
     */
    public static void saveListElectrodomestic(List<Electrodomestic> ll, String nomFitxer) {        
        ObjectOutputStream oos = null;
        try {
            oos = new ObjectOutputStream(new FileOutputStream(nomFitxer));
            oos.writeObject(ll);
        } catch (FileNotFoundException ex) {
            throw new ElectrodomesticFitxerBinariSerialitzatException("Error en crear arxiu " + nomFitxer, ex);
        } catch (IOException ex) {
            throw new ElectrodomesticFitxerBinariSerialitzatException("Error en enregistrar dada", ex);
        } finally {
            if (oos != null) {
                try {
                    oos.close();
                } catch (IOException ex) {
                    throw new ElectrodomesticFitxerBinariSerialitzatException("Error en tancar arxiu " + nomFitxer, ex);
                }
            }
        }
    }

    public static List<Electrodomestic> loadListElectrodomestic(String nomFitxer) {
        ObjectInputStream ois = null;
        try {
            ois = new ObjectInputStream(new FileInputStream(nomFitxer));
            List<Electrodomestic> ll = (List<Electrodomestic>) ois.readObject();
            return ll;
        } catch (FileNotFoundException ex) {
            throw new ElectrodomesticFitxerBinariSerialitzatException("Error en obrir arxiu " + nomFitxer, ex);
        } catch (IOException | ClassNotFoundException ex) {
            throw new ElectrodomesticFitxerBinariSerialitzatException("Error en recuperar dada", ex);
        } finally {
            if (ois != null) {
                try {
                    ois.close();
                } catch (IOException ex) {
                    throw new ElectrodomesticFitxerBinariSerialitzatException("Error en tancar arxiu " + nomFitxer, ex);
                }
            }
        }
    }
}
