/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals;

import java.util.Arrays;
import java.util.GregorianCalendar;
import java.util.List;
import org.milaifontanals.persistence.ElectrodomesticFitxerXmlV1ViaJaxb;
import org.milaifontanals.persistence.ElectrodomesticFitxerXmlV1ViaJaxbException;

/**
 *
 * @author Usuari
 */
public class P01_GenerarFitxerXml {

    public static void main(String[] args) {
        List<Electrodomestic> ll = crearLlista();
        System.out.println("Contingut d'objectes de la llista que enregistrem:");
        for (Electrodomestic el : ll) {
            System.out.println("\t" + el);
        }
        Electrodomestic.setDteVigent(0.02F);
        System.out.println("Valors de les dades estàtiques:");
        System.out.println("\tDte. vigent: " + Electrodomestic.getDteVigent());

        String nomFitxer = "LlistaElectrodomesticV1.xml";
        try {
            ElectrodomesticFitxerXmlV1ViaJaxb.saveListElectrodomestic(ll, nomFitxer);
            System.out.println("Fitxer generat sense cap error");
        } catch (ElectrodomesticFitxerXmlV1ViaJaxbException ex) {
            System.out.println("Error en generar arxiu " + nomFitxer);
            System.out.println("+ Info:" + ex.getMessage());
            Throwable aux = ex.getCause();
            while ((aux) != null) {
                if (aux.getMessage() != null) {
                    System.out.println("\t" + aux.getMessage());
                }
                aux = aux.getCause();
            }
        }
    }

    private static List<Electrodomestic> crearLlista() {
        // Aquest mètode crea una array d'electrodomèstics... aprofitat d'un altre
        // programa... Al final, es converteix en List amb utilitat Arrays.asList

        Electrodomestic[] array = new Electrodomestic[16];

        double[] mides = new double[3];
        mides[0] = 845;
        mides[1] = 598;
        mides[2] = 590;

        array[0] = new GammaBlanca(1, "Rentadora", "Balay", 679.78, mides);
        array[1] = new GammaBlanca(2, "Rentadora", "Miele", 749, 850.5, 596.2, 636.4);
        array[2] = new GammaGris(3, "Portàtil", "HP", 499, "15S-fq2095ns");
        Byte g = 1;
        array[3] = new GammaGris(4, "Portàtil", "Lenovo", 379, g, new GregorianCalendar(2020, 11, 29), "IdeaPad 3 15IGL05", "A", 16);
        mides[0] = 595;
        mides[1] = 595;
        mides[2] = 559;

        array[4] = new GammaBlanca(5, "Forn", "Teka", 209.99, mides);
        array[5] = new GammaBlanca(6, "Forn", "Balay", 199.99, 595, 594, 595);
        array[6] = new GammaGris(7, "Tablet", "Lenovo", 185, "Tab M10 FHD Plus");
        array[7] = new GammaGris(8, "Tablet", "Huawei", 109, g, new GregorianCalendar(2021, 2, 15), "MatePadT 10", "B", 8);

        mides[0] = 203;
        mides[1] = 60;
        mides[2] = 65;

        array[8] = new GammaBlanca(9, "Nevera", "Bosch", 579.99, mides);
        array[9] = new GammaBlanca(10, "Nevera", "Fagor", 599, 186, 60, 65);
        array[10] = new GammaGris(11, "Impressora", "Brother", 739, "HL-L9310CDW");
        array[11] = new GammaGris(12, "Impressora", "Canon", 78.99, "PIXMA MG3650S");

        mides[0] = 85;
        mides[1] = 60;
        mides[2] = 60;

        array[12] = new GammaBlanca(13, "Rentaplats", "Indesit", 374, mides);
        array[13] = new GammaBlanca(14, "Rentaplats", "Electrolux", 429, 85, 60, 62.5);
        array[14] = new GammaGris(15, "Impressora", "Epson", 184, "ECOTANK ET-2714");
        array[15] = new GammaGris(16, "Impressora", "HP", 54.99, "DeskJet 2721e");

        Arrays.sort(array);   // S'aplica ordre natural. 
        // Aquesta ordenació és simplement per a que nop estiguin ordenades per "id",
        // que és camp que es crea automàticament.

        List ll = Arrays.asList(array);
        return ll;
    }

}
